//+------------------------------------------------------------------+
//|                                           Volume Wave Expert.mq4 |
//|                                      credit Progammer Master TnR |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Volume Wave PT CEO Adi Putranto"

#property indicator_separate_window
#property indicator_minimum 0

#property indicator_buffers 5
#property indicator_color1  Gray
#property indicator_color2  Green
#property indicator_color3  Red
#property indicator_color4  Magenta
#property indicator_color5  Magenta
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

extern bool    AlertEmail=false;
extern bool    AlertSound=true;
extern bool    AlertPopup=true;

extern bool ShowNormalVolume = true;
extern int  Search_Distance = 10;

datetime       LastAlert;

double red[],green[];

//---- indicator buffers
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];
//----

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexLabel(1,"GREEN");
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexLabel(2,"RED");
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_ARROW);

   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   SetIndexBuffer(4,ExtBuffer5);
   SetIndexArrow(4,78);
   
   IndicatorShortName("VOLUME WAVE CORE("+Search_Distance+")");
   SetIndexLabel(0,"Volume");
   IndicatorDigits(0);
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
  
string PeriodToText(int per) {

   switch (per)
   {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN1");
   }
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,status;
   int counted_bars=IndicatorCounted();
//----
	if (counted_bars>0) counted_bars--;
	limit=Bars-counted_bars;
	
	for (int i=limit; i>=0; i--){
		status=0;
		if (iHigh(NULL,0,i)>=iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Search_Distance,i))) status+=1;
		if (iLow(NULL,0,i)<=iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Search_Distance,i)))     status+=2;
		switch(status){
			case 0:  if (ShowNormalVolume) ExtBuffer1[i]=Volume[i]; break;
			case 1:  ExtBuffer2[i]=Volume[i]; break;
			case 2:  ExtBuffer3[i]=Volume[i]; break;
			default: ExtBuffer4[i]=Volume[i]; ExtBuffer5[i]=Volume[i]+(Period()*30); break;
		}
	}
//----

//----Alert Code - gah

   if (AlertEmail || AlertSound || AlertPopup)
      if (Time[0] != LastAlert) {
         LastAlert = Time[0];

         if (ExtBuffer3[1] > 0 && ExtBuffer3[1] != EMPTY_VALUE) {
            if (AlertSound)
               PlaySound("alert.wav");
            if (AlertPopup)
               Alert(Symbol() +" "+PeriodToText(Period())+ " RED at " + TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES));
            if (AlertEmail)
               SendMail(WindowExpertName() + " - " + Symbol() +" "+PeriodToText(Period())+ " RED at " + TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES),"New Climax High");
         }//if (red[1] > 0)          

         if (ExtBuffer2[1] > 0 && ExtBuffer2[1] != EMPTY_VALUE) {
            if (AlertSound)
               PlaySound("alert.wav");
            if (AlertPopup)
               Alert(Symbol() +" "+PeriodToText(Period())+ " GREEN at " + TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES));
            if (AlertEmail)
               SendMail(WindowExpertName() + " - " + Symbol() +" "+PeriodToText(Period())+ " GREEN at " + TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES),"New Climax Low");
         }//if (green[1] > 0) 
         
      }//if (Time[0] != LastAlert) 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+